using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Components.Containers;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Driver;
using MudBlazor;
using System.Text.RegularExpressions;
using SortDirection = MudBlazor.SortDirection;

namespace Insight.Web.Pages.Management.Hosts.Systems.Services;

[Route(Navigation.Management.Hosts.Systems.Services.Index)]
public partial class Index
{
    [Parameter] public string? HostId { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private NavigationManager NavigationManager { get; init; } = default!;

    private TableContainer<HostServiceEntity>? Container { get; set; }
    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private string? Search { get; set; }

    protected override async Task OnInitializedAsync()
    {
        if (string.IsNullOrWhiteSpace(HostId) || ObjectId.TryParse(HostId, out var hostId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        var host = await Database.Host()
            .Find(Builders<HostEntity>
            .Filter
            .Eq(p => p.Id, HostId))
            .FirstOrDefaultAsync(default);

        if (host is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        Title = $"Hosts » {host.Name} » Services｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Hosts", href: Navigation.Management.Hosts.Index));
        Breadcrumbs.Add(new BreadcrumbItem(host.Name, href: Navigation.Management.Hosts.DetailsHref(HostId)));
        Breadcrumbs.Add(new BreadcrumbItem("Services", href: "#", true));
    }

    private async Task<TableData<HostServiceEntity>> LoadDataAsync(TableState state)
    {
        try
        {
            var filter = Builders<HostServiceEntity>.Filter.Eq(p => p.Host, HostId);

            if (string.IsNullOrWhiteSpace(Search) is false)
            {
                var regex = new BsonRegularExpression(new Regex(Search, RegexOptions.IgnoreCase));
                filter &= Builders<HostServiceEntity>.Filter.Regex(x => x.Name, regex) |
                    Builders<HostServiceEntity>.Filter.Regex(x => x.DisplayName, regex) |
                    Builders<HostServiceEntity>.Filter.Regex(x => x.Company, regex) |
                    Builders<HostServiceEntity>.Filter.Regex(x => x.Description, regex) |
                    Builders<HostServiceEntity>.Filter.Regex(x => x.StartMode, regex) |
                    Builders<HostServiceEntity>.Filter.Regex(x => x.Delay, regex) |
                    Builders<HostServiceEntity>.Filter.Regex(x => x.State, regex) |
                    Builders<HostServiceEntity>.Filter.Regex(x => x.ProcessId, regex) |
                    Builders<HostServiceEntity>.Filter.Regex(x => x.Account, regex);
            }

            var query = Database.HostService()
                .Find(filter)
                .Sort(state.SortDirection switch
                {
                    SortDirection.Ascending => state.SortLabel switch
                    {
                        "Name" => Builders<HostServiceEntity>.Sort.Ascending(p => p.Name),
                        "DisplayName" => Builders<HostServiceEntity>.Sort.Ascending(p => p.DisplayName),
                        "Company" => Builders<HostServiceEntity>.Sort.Ascending(p => p.Company),
                        "Description" => Builders<HostServiceEntity>.Sort.Ascending(p => p.Description),
                        "StartMode" => Builders<HostServiceEntity>.Sort.Ascending(p => p.StartMode),
                        "Delay" => Builders<HostServiceEntity>.Sort.Ascending(p => p.Delay),
                        "State" => Builders<HostServiceEntity>.Sort.Ascending(p => p.State),
                        "ProcessId" => Builders<HostServiceEntity>.Sort.Ascending(p => p.ProcessId),
                        "Account" => Builders<HostServiceEntity>.Sort.Ascending(p => p.Account),
                        _ => null
                    },
                    SortDirection.Descending => state.SortLabel switch
                    {
                        "Name" => Builders<HostServiceEntity>.Sort.Descending(p => p.Name),
                        "DisplayName" => Builders<HostServiceEntity>.Sort.Descending(p => p.DisplayName),
                        "Company" => Builders<HostServiceEntity>.Sort.Descending(p => p.Company),
                        "Description" => Builders<HostServiceEntity>.Sort.Descending(p => p.Description),
                        "StartMode" => Builders<HostServiceEntity>.Sort.Descending(p => p.StartMode),
                        "Delay" => Builders<HostServiceEntity>.Sort.Descending(p => p.Delay),
                        "State" => Builders<HostServiceEntity>.Sort.Descending(p => p.State),
                        "ProcessId" => Builders<HostServiceEntity>.Sort.Descending(p => p.ProcessId),
                        "Account" => Builders<HostServiceEntity>.Sort.Descending(p => p.Account),
                        _ => null
                    },
                    _ => Builders<HostServiceEntity>.Sort.Ascending(p => p.DisplayName)
                });

            return new TableData<HostServiceEntity>()
            {
                TotalItems = (int)await query.CountDocumentsAsync(default),
                Items = await query.Skip(state.Page * state.PageSize).Limit(state.PageSize).ToListAsync(default)
            };
        }
        catch (Exception)
        {
            Notification.Error(Snackbar);
            return new TableData<HostServiceEntity>();
        }
    }
}